﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using Buddy.BehaviorTree;
using Buddy.Common;
using Buddy.Common.Math;
using Buddy.CommonBot;
using Buddy.Swtor;
using Action = Buddy.BehaviorTree.Action;
using Buddy.Swtor.Objects;

namespace SwtorNoobRage
{
    class Sorcerer : Healer
    {
        private Cast Cast = new Cast();
        private static TorCharacter tank { get { return NRhealer.tank; } }
        private static TorCharacter HealTarget { get { return NRhealer.HealTarget; } }

        public override Composite Resurrect
        {
            get
            {
                return new Action(delegate 
                {
                    if (Cast.Rez("Revive"))
                        return RunStatus.Success;
                    else
                        return RunStatus.Failure;
                });
            }
        }

        public override Composite SelfCheck
        {
            get 
            {
                return new Action(delegate
                {
                    if (Cast.Spell("Seethe", Me, !Me.InCombat && (Me.ForcePercent < 70 || Me.HealthPercent < 70)))
                        return RunStatus.Success;

                    return RunStatus.Failure;
                }
                );
            }
        }

        public override Composite Cleansing
        {
            get
            {
                return new Action(delegate
                {
                    return RunStatus.Failure;
                }
                );
            }
        }

        public override Composite CleansingUrgent
        {
            get
            {
                return new Action(delegate
                {
                    return RunStatus.Failure;
                }
                );
            }
        }

        public override Composite TankCheck
        {
            get
            {
                return new Action(delegate
                {
                    return RunStatus.Failure;
                }
                );
            }
        }

        public override Composite Healing
        {
            get {

                return new Action(delegate
                    {
                        Helpers.SetHealTarget();
                        if (HealTarget != null)
                        {
                            Cast.Spell("Recklessness", Me, Helpers.AOEHealCount(60, 30) >= 2);

                            if (Cast.Spell("Static Barrier", HealTarget, !HealTarget.HasBuff("Static Barrier") && HealTarget.HealthPercent < 80))
                                return RunStatus.Success;

                            if (Cast.Spell("Dark Heal", HealTarget, HealTarget.HealthPercent < 50))
                                return RunStatus.Success;

                            if (Cast.Spell("Dark Infusion", HealTarget, HealTarget.HealthPercent < 85))
                                return RunStatus.Success;                            
                        }
                        return RunStatus.Failure;
                    }
                );
            }
        }        

        public override Composite Buff
        {
            get
            {
                return new Action(delegate
                {
                    if (Cast.Spell("Sprint", Me, Helpers.NeedBuff("Sprint") && !Me.InCombat))
                        return RunStatus.Success;
                    if (Cast.Spell("Mark of Power", Me, Helpers.NeedBuff("Mark of Power")))
                        return RunStatus.Success;
                    return RunStatus.Failure;
                }
                );
            }
        }
        public override Composite DPS
        {
            get
            {
                return new Action(delegate
                {
                    if (Me.CurrentTarget != null && !Me.IsMoving)
                    {
                        if (Cast.Spell("Crushing Darkness", Me.CurrentTarget, true))
                            return RunStatus.Success;
                        if (Cast.Spell("Force Lightning", Me.CurrentTarget, true))
                            return RunStatus.Success;                        
                        if (Cast.Spell("Shock", Me.CurrentTarget, true))
                            return RunStatus.Success;
                    }
                    return RunStatus.Failure;
                }
                );
            } 
        }
    }
}