﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using Buddy.BehaviorTree;
using Buddy.Common;
using Buddy.Common.Math;
using Buddy.CommonBot;
using Buddy.Swtor;
using Action = Buddy.BehaviorTree.Action;
using Buddy.Swtor.Objects;

namespace SwtorNoobRage
{
    class Cast
    {
        private static Buddy.Swtor.Objects.TorPlayer Me { get { return BuddyTor.Me; } }

        #region checks

        public static bool HasSpell(string spell) 
        { 
             return AbilityManager.KnownAbilities.Any(a=> a.Name == spell); 
        }  

        public static TorAbility getSpell(string spell)
        {
            if(!HasSpell(spell))
                return null;

            return (TorAbility)AbilityManager.KnownAbilities.Where(a=> a.Name == spell);
        }     

        public static bool CanCast(string spell, TorCharacter u)
        {
            if (AbilityManager.CanCast(spell, u))            
                return true;            
            else
            {
                Logging.Write("Can't cast on " + u.Name);
                return false;
            }
        }
        #endregion

        #region Spell Casting
        public static bool Spell(string spell, TorCharacter u, bool b)
        {
            if (b && CanCast(spell, u))
            {
                Logging.Write(spell + "  " + u.Name + "  " + u.HealthPercent);
                AbilityManager.Cast(spell, u);
                return true;
            }
            else
                return false;

        }
        public bool Spell(string spell, TorCharacter u)
        {
            return Spell(spell, u,  true);
        }
        public bool Spell(string spell)
        {
            return Spell(spell, Me.CurrentTarget);
        }

        public bool Rez(string spell)
        {
            TorCharacter tar = Helpers.RezTarget();
            return Spell(spell, tar, tar != null);
        }

        #endregion

    }
}
