﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using Buddy.BehaviorTree;
using Buddy.Common;
using Buddy.Common.Math;
using Buddy.CommonBot;
using Buddy.Swtor;
using Action = Buddy.BehaviorTree.Action;
using Buddy.Swtor.Objects;

namespace SwtorNoobRage
{
    class Helpers
    {
        private static Buddy.Swtor.Objects.TorPlayer Me { get { return BuddyTor.Me; } }
        private Cast Cast = new Cast();
        public static int QueryHealth = 95;
        public static int QueryDist = 30;

        public static Composite Wait
        {
            get
            {
                return new Action(delegate
                {
                    if (Me.IsCasting)
                        return RunStatus.Success;
                    else
                        return RunStatus.Failure;
                });
            }
        }

        public static bool SetHealTarget()
        {
            NRhealer.HealTarget = GetHealTarget();
            if (NRhealer.HealTarget != null)
            {
                Logging.Write(NRhealer.HealTarget.Name + "  " + NRhealer.HealTarget.HealthPercent);
                return true;
            }
            else
                return false;
        }

        public static TorCharacter GetHealTarget()
        {
            //need blacklisting
            //need debuffs to omit
            return (from unit in Party()
                    orderby unit.HealthPercent ascending
                    where !unit.IsDead
                    where unit.Distance < QueryDist
                    where unit.InLineOfSight
                    where unit.HealthPercent < QueryHealth
                    select unit).FirstOrDefault();
        }

        public static TorCharacter LowestAggroed()
        {
            return (from unit in Aggroed()
                    orderby unit.HealthPercent ascending
                    where unit.InLineOfSight
                    select unit).FirstOrDefault();
        }

        public static TorCharacter RezTarget()
        {
            return (from unit in Party()
                    orderby unit.Distance ascending
                    where unit.InLineOfSight
                    where unit.Name != Me.Companion.Name
                    where unit.IsDead
                    select unit).FirstOrDefault();
        }

        public static List<TorCharacter> Party()
        {
            return ObjectManager.GetObjects<TorCharacter>().Where(p => p.IsFriendly).ToList();
        }

        public static List<TorCharacter> Hostiles()
        {
            return ObjectManager.GetObjects<TorCharacter>().Where(p => p.IsHostile).ToList();
        }

        public static List<TorCharacter> Aggroed()
        {
            return Party().Where(p => !p.IsDead && p.Distance < QueryDist && PlayerAggroed(p)).ToList();
        }
                             
        public static bool HasAura(TorCharacter p, string aura)
        {
            return p.Buffs.Any(a => a.Name == aura);
        }       

        public static int AOEHealCount(int hp, int dist)
        {
            return Party().Count(p => !p.IsDead && p.Distance < dist && p.HealthPercent <= hp);            
        }

        public static bool PlayerAggroed(TorCharacter p) 
        { 
             return Hostiles().Any(x => x.CurrentTarget!=null && x.CurrentTarget.Name == p.Name); 
        }

        public static bool PlayerInPary(TorCharacter p)
        {
            return Party().Any(x => x.Name == p.Name);
        }

        public static bool NeedBuff(string buff)
        {
            return Party().Any(p => !HasAura(p, buff));
        }
    }
}
